﻿# $author = T. Butz, 
# $version = 2014.07.18
# $url = 'www.thorsten-butz.de'; $twitter = $adn = '@thorstenbutz'

<#
.SYNOPSIS
This scripts eports CSV files from an XLS file with one ore more worksheets
 
.DESCRIPTION
This scripts creates an Excel COM object, loads an XLS file and exports all worksheets to CSV files.
 
.EXAMPLE
Export-TBXLStoCSV c:\temp\mydata.xls
 
.PARAMETER file
A file path to the source XLS file.

.NOTES
(intentionally left blank)
 
.LINK
http://www.thorsten-butz.de/
https://github.com/thorstenbutz/
#>

[CmdletBinding()]

param (
  [Parameter(Mandatory=$false,ValueFromPipeline=$true)]
  [string]$file
)

if (!$file){
  $file = read-host 'Source path to XLS file'
  $file = $file -replace '"'
  }

if (!(test-path $file)){"$file not found, quitting!" ; exit }

$path = (Get-ChildItem $file).DirectoryName
$File = (Get-ChildItem $file).FullName

$Excel = New-Object -Com Excel.Application 
$Excel.visible = $False 
$Excel.displayalerts=$False 

$WorkBook = $Excel.Workbooks.Open($file) 


$WorkBook.Worksheets | ForEach-Object {
 $_.SaveAs("$path\$($_.name).csv",6) 
}

$Excel.quit()